$(document).on('click','.navbar-collapse.in',function(e) {
    if( $(e.target).is('a') && $(e.target).attr('class') != 'dropdown-toggle' ) {
        $(this).collapse('hide');
    }
});
app = angular.module('app', ['ngRoute','ngSanitize','ngAnimate']);
app.filter('objfilter', function() {
  return function(input, search) {
    if (!input) return input;
    if (!search) return input;
    var expected = ('' + search).trim().toLowerCase();
    var result = {};
    angular.forEach(input, function(value, key) {
      if(angular.toJson(value).toLowerCase().indexOf(expected)>=0) result[key] = value;
    });
    return result;
  }
});
app.filter('trustAsHTML', ['$sce', function($sce) {
    return function(val) {
        return $sce.trustAsHtml(val);
    };
}])
app.directive('no', function($window){
    return {
        restrict: 'A',
        require: 'ngModel',
        link: function(scope, element, attrs, modelCtrl) {
            element.on('click',function(){if(!$window.getSelection().toString()){this.setSelectionRange(0,this.value.length)}});
            modelCtrl.$parsers.push(function (val) {
                if (val == undefined) return '';
                var newval = val.replace(',','.').replace(/[^0-9\-\.]/g, '').replace(/^0+(?!\.|$)/, '').replace(/^(\-?[^\.\-]*\.?[^\.\-]*)[\-\.]*.*$/g,'$1'); 
                if (newval!=val){
                    modelCtrl.$setViewValue(newval);
                    modelCtrl.$render();
                }
                return newval;         
            });
        }
    };
});
app.directive('xinclude', function($parse,$rootScope) {
  return {
      restrict: 'A',
      templateUrl: function(element,attr) {
          return $parse(attr.xinclude)($rootScope);
      }
  };
});
app.run(['$rootScope', function($rootScope) {
    $rootScope.isNaN = window.isNaN;
    $rootScope.sitemap = window.sitemap;
    $rootScope.$window = window;
    setInterval(function(){$('.page-header,.alert-warning').hide();},500);
    
    $rootScope.cv = function(obj,type,unit,value){
        if(value===undefined) value = obj[unit];
        var p = {mmhg:1,bar:0.001333223684211,hpa:1.333223684211,millibar:1.333223684211,atm:0.001315789473684,psi:0.01933679515879};
        var l = {ft:1,mm:304.8,cm:30.48,mt:0.3048,km:0.0003048,sm:0.0001893939393939,nm:0.0001645788336933};
        var s = {knot:1,kmh:1.852,mph:1.15078,mps:0.514445};

        if(type==='p'){for(var k in p){if(k!=unit) obj[k] = Math.round(1000000000*value/p[unit]*p[k])/1000000000;}
        }else if(type==='l'){ for(var k in l){if(k!=unit) obj[k] = Math.round(1000000000*value/l[unit]*l[k])/1000000000;}
        }else if(type==='s'){ for(var k in s){if(k!=unit) obj[k] = Math.round(1000000000*value/s[unit]*s[k])/1000000000;}
        }else if(type==='t'){
            if(unit==='c')obj.f = 32 + 1.8*obj.c;
            if(unit==='f')obj.c = (obj.f-32) / 1.8; 
        }
        return obj;
    };
    $rootScope.e6b = function(obj){
        obj.c = (obj.c || 0)*1 || 0; 
        obj.wd = (obj.wd || 0)*1 || 0; 
        obj.ws = (obj.ws || 0)*1 || 0; 
        obj.tas = (obj.tas || 0)*1 || 0; 
        var C = Math.PI/180;
        var crs = C * (obj.c%360);
        var wd = C * obj.wd;
        var swc = (obj.ws/obj.tas) *  Math.sin(wd - crs);
        if(Math.abs(swc) > 1 || !obj.tas){
            obj.h = obj.gs = obj.wca = "N/A";
            return false;
        }
        var hd = crs + Math.asin(swc);
        hd = (hd < 0) ? (hd + 2 * Math.PI):((hd > 2*Math.PI)?(hd - 2 * Math.PI): hd);
        obj.h = Math.round(1/C * hd);
        obj.gs = Math.round(obj.tas * Math.sqrt(1 - Math.pow(swc, 2)) - (obj.ws * Math.cos(wd - crs)));
        obj.wca = Math.round(1/C * (Math.atan2(obj.ws * Math.sin(hd-wd), obj.tas-obj.ws *  Math.cos(hd-wd)) * -1));
        return obj;
    };
    $rootScope.apc = function(unit){
        if(!$rootScope.apo) $rootScope.apo = {};
        if(!$rootScope.deno) $rootScope.deno = {};
        var obj = $rootScope.apo;
        if(!obj.pa) obj.pa = {};
        if(!obj.fe) obj.fe = {};
        if(!$rootScope.deno.pa) $rootScope.deno.pa = {};
        if(!$rootScope.deno.ta) $rootScope.deno.ta = {};
        if(isNaN(obj.fe.ft)) obj.fe.ft = 0;
        if(unit==='pa') obj.as = Math.round(-100*((obj.pa.ft - obj.fe.ft)/1000-29.92))/100;
        if(unit==='as') obj.pa.ft = Math.round((29.92-obj.as)*1000+parseInt(obj.fe.ft));
        $rootScope.cv(obj.pa,'l','ft');
        $rootScope.cv(obj.fe,'l','ft');
        $rootScope.deno.pa.ft = obj.pa.ft;
        $rootScope.deno.ta.ft = obj.fe.ft;
        $rootScope.cv($rootScope.deno.pa,'l','ft');
        $rootScope.cv($rootScope.deno.ta,'l','ft');
    };
    $rootScope.denc = function(){
        if(!$rootScope.deno) $rootScope.deno = {};
        var obj = $rootScope.deno;
        if(!obj.pa) obj.pa = {};
        if(!obj.ta) obj.ta = {};
        if(!obj.isa) obj.isa = {};
        if(!obj.oat) obj.oat = {};
        if(!obj.da) obj.da = {};
        if(!obj.pa.ft) obj.pa.ft = 0;
        if(!obj.ta.ft) obj.ta.ft = 0;
        if(!obj.oat.c) obj.oat.c = 0;
        $rootScope.cv(obj.pa,'l','ft');
        $rootScope.cv(obj.ta,'l','ft');
        $rootScope.cv(obj.oat,'t','c');
        obj.isa.c = 15 - 1.98 * obj.ta.ft / 1000;
        $rootScope.cv(obj.isa,'t','c');
        obj.da.ft = parseFloat(obj.pa.ft) + 118.8 * (obj.oat.c-obj.isa.c);
        $rootScope.cv(obj.da,'l','ft');
    };
    $rootScope.windc = function(){
        if(!$rootScope.windo) $rootScope.windo = {};
        var obj = $rootScope.windo;
        if(!obj.wd) obj.wd=0;
        if(!obj.ws) obj.ws=0;
        if(!obj.rd) obj.rd=0;
        obj.wa = (obj.wd-obj.rd*10)%360;
        obj.war = obj.wa/360*2*Math.PI;
        obj.hw=obj.ws * Math.cos(obj.war);
        obj.cw=obj.ws * Math.abs(Math.sin(obj.war));
        obj.arrowx1 = 200+ 70 * Math.sin(obj.war);
        obj.arrowx2 = 200+ 120 * Math.sin(obj.war);
        obj.arrowy1 = 200- 70 * Math.cos(obj.war);
        obj.arrowy2 = 200- 120 * Math.cos(obj.war);
    };
    $rootScope.cbac = function(){
        if(!$rootScope.cbao) $rootScope.cbao = {};
        var obj = $rootScope.cbao;
        if(!obj.at) obj.at={};
        if(!obj.ad) obj.ad={};
        if(!obj.sa) obj.sa={};
        if(!obj.cb) obj.cb={};
        if(!obj.at.c) obj.at.c=0;
        if(!obj.ad.c) obj.ad.c=0;
        if(!obj.sa.ft) obj.sa.ft=0;
        $rootScope.cv(obj.at,'t','c');
        $rootScope.cv(obj.ad,'t','c');
        $rootScope.cv(obj.sa,'l','ft');
        obj.cb.ft = parseFloat(obj.sa.ft)+(obj.at.f-obj.ad.f)/4.5*1000 ;
        $rootScope.cv(obj.cb,'l','ft');
    };
    $rootScope.machc=function(){
        $rootScope.error = false
        if(!$rootScope.macho) $rootScope.macho = {};
        var obj = $rootScope.macho;
        if(!obj.alt) obj.alt={};
        if(!obj.st) obj.st={};
        if(!obj.at) obj.at={};
        if(!obj.ms) obj.ms={};
        $rootScope.cv(obj.alt,'l','ft');
        $rootScope.cv(obj.at,'t','c');
        if ((obj.alt.mt < -2000) || (obj.alt.mt > 86000)) $rootScope.error = true;
        var a = [0, 11000, 20000, 32000, 47000, 51000, 71000, 84852],i = 0;
        if (obj.alt.mt > 0) while (obj.alt.mt > a[i+1]) i++;
        obj.st.c = [15,-56.5,-56.5,-44.5,-2.5,-2.5,-58.5,-86.204][i] + -0.0065 * (obj.alt.mt - a[i]);
        obj.ms.mps = Math.sqrt(1.4 * 287.053 * ((obj.at.c?obj.at.c*1:obj.st.c)+273.15));
        $rootScope.cv(obj.st,'t','c');
        $rootScope.cv(obj.ms,'s','mps');
    };
    $rootScope.tasc = function(){
        var obj = $rootScope.taso;
        if(!obj.ias) obj.ias = {};
        if(!obj.alt) obj.alt = {};
        if(!obj.oat) obj.oat = {};
        obj.tas = {};
        obj.tas.knot = obj.ias.knot * 1 / Math.pow(Math.pow((288.15 - (obj.alt.ft*1 + (288.15 - obj.alt.ft * 0.0019812) / 0.0019812  *(1 - Math.pow((288.15 - obj.alt.ft * 0.0019812) /(obj.oat.c*1 + 273.15), 0.234969))) * 0.0019812) / 288.15, 1 / 0.234969), .5);
        $rootScope.cv(obj.tas,'s','knot');
    };
    $rootScope.e6bo = {c:320,tas:100,wd:90,ws:23};
    $rootScope.e6bwo = {};
    $rootScope.timeo = {};
    $rootScope.fuelo = {};
    $rootScope.timec = function(){
        var obj = $rootScope.timeo;
        var d = (obj.d || 0)*1 || 0; 
        var gs = (obj.gs || 0)*1 || 0; 
        obj.t = (d/gs*60).toFixed(2)*1; 
        $rootScope.fuelo.t = obj.t*1;
    };
    $rootScope.e6bc = function(){
        var C = Math.PI/180;
        $rootScope.error=false;
        var obj = $rootScope.e6b($rootScope.e6bo);
        if(obj==false) return $rootScope.error=true;
        obj.arrowx1 = 200+ 120 * Math.sin(C * obj.wd);
        obj.arrowx2 = 200+ 160 * Math.sin(C * obj.wd);
        obj.arrowy1 = 200- 120 * Math.cos(C * obj.wd);
        obj.arrowy2 = 200- 160 * Math.cos(C * obj.wd);
        obj.headingx = 200+ 70*obj.tas/(obj.ws+obj.tas) * Math.sin(C * obj.h);
        obj.headingy = 200- 70*obj.tas/(obj.ws+obj.tas) * Math.cos(C * obj.h);
        obj.coursex = 200+ 70*obj.gs/(obj.ws+obj.tas) * Math.sin(C * obj.c);
        obj.coursey = 200- 70*obj.gs/(obj.ws+obj.tas) * Math.cos(C * obj.c);
        $rootScope.timeo.gs = obj.gs*1;
        $rootScope.timec();
    };
    $rootScope.e6bc();
    $rootScope.e6bwc = function(){
        var obj = $rootScope.e6bwo;
        obj.c = (obj.c || 0)*1 || 0; 
        obj.h = (obj.h || 0)*1 || 0; 
        obj.tas = (obj.tas || 0)*1 || 0; 
        obj.gs = (obj.gs || 0)*1 || 0; 
        var c = (Math.PI/180)* obj.c;
        var h = (Math.PI/180)* obj.h;
        obj.ws = Math.round(Math.sqrt(Math.pow(obj.tas-obj.gs, 2) + 4*obj.tas*obj.gs* Math.pow(Math.sin((h-c)/2), 2)));
        var wd = c + Math.atan2(obj.tas * Math.sin(h-c), obj.tas * Math.cos(h-c) - obj.gs);
        if (wd<0) { wd=wd+2*Math.PI; }
        if (wd>2*Math.PI) { wd=wd-2*Math.PI;}
        obj.wd=Math.round((180/Math.PI) * wd);
    };
    $rootScope.e6btasc = function(){
        $rootScope.taso.tas = Math.round($rootScope.taso.ias * 1 / Math.pow(Math.pow((288.15 - ($rootScope.taso.alt*1 + (288.15 - $rootScope.taso.alt * 0.0019812) / 0.0019812  *(1 - Math.pow((288.15 - $rootScope.taso.alt * 0.0019812) /($rootScope.taso.oat*1 + 273.15), 0.234969))) * 0.0019812) / 288.15, 1 / 0.234969), .5));
    };
    $rootScope.navlogodefault = {
        tank : '',
        list : [{},{},{},{},{}],
        iasenable : false,
        chart: {
            type : "ColumnChart",
            options : {'title': 'Profile View'},
            data : {
                "cols": [{id: "t", label: "CheckPoints", type: "string"},{id: "s", label: "Feet", type: "number"}],
                "rows": [{c: [{v: "Start"},{v:0}]},{c: [{v: "End"},{v:0}]}]
            }
        }
    };
    $rootScope.navlogo = localStorage.getItem('navlogo')?angular.fromJson(localStorage.getItem('navlogo')):angular.copy($rootScope.navlogodefault);

    $rootScope.navlogreset = function(){if(confirm('Do you want to reset table?'))$rootScope.navlogo = angular.copy($rootScope.navlogodefault);};
    $rootScope.navlogfuelrem = function(x){
        var sum=$rootScope.navlogo.tank || 0;
        for(var i=0;i<$rootScope.navlogo.list.length;i++){
            var v = $rootScope.navlogo.list[i];
            if(v==x) return sum-((x.fused || 0)*1 || 0);
            else sum-=(v.fused || 0)*1 || 0;
        }
        return sum;
    };
    $rootScope.navlogc = function(v){
        if($rootScope.navlogo.iasenable) v.tas = Math.round(v.ias * 1 / Math.pow(Math.pow((288.15 - (v.alt*1 + (288.15 - v.alt * 0.0019812) / 0.0019812  *(1 - Math.pow((288.15 - v.alt * 0.0019812) /(v.oat*1 + 273.15), 0.234969))) * 0.0019812) / 288.15, 1 / 0.234969), .5));
        v = $rootScope.e6b(v);
        var tmpvar = (v.var || 0)*1 || 0; 
        var tmpdev = (v.dev || 0)*1 || 0; 
        var tmpdist = (v.dist || 0)*1 || 0; 
        var tmpfph = (v.fph || 0)*1 || 0; 
        v.mh = (1*v.h+1*tmpvar) % 360;
        v.ch = (1*v.h+1*tmpvar+1*tmpdev) % 360;
        v.time = v.gs>0?tmpdist/v.gs*60:0;
        v.fused = v.gs>0?tmpdist/v.gs*tmpfph:0;
        $rootScope.navlogo.chart.data.rows = [{c: [{v: "Start"},{v:0}]}];
        $rootScope.navlogo.list.forEach(function(v){if(v.alt && v.alt>0) $rootScope.navlogo.chart.data.rows.push({c: [{v:v.cpn?v.cpn:'CheckPoint'},{v:(v.alt || 0)*1 || 0}]});});
        $rootScope.navlogo.chart.data.rows.push({c: [{v: "End"},{v:0}]});
        $rootScope.navlogo.list.forEach(function(v){v.frem = $rootScope.navlogfuelrem(v);});
        localStorage.setItem('navlogo', angular.toJson($rootScope.navlogo));
    };
    $rootScope.navlogsum = function(x){
        var sum=0;
        $rootScope.navlogo.list.forEach(function(v){sum+=(v[x] || 0)*1 || 0;});
        return sum;
    };
    
}]);
